<?php

namespace app\admin\controller;

use app\common\controller\Backend;
use think\Db;
/**
 * 出发班次
 *
 * @icon fa fa-circle-o
 */
class Productchufabanci extends Backend
{

    /**
     * Productchufabanci模型对象
     * @var \app\admin\model\Productchufabanci
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\Productchufabanci;
        $this->view->assign("chufatypeList", $this->model->getChufatypeList());
        $this->view->assign("facheStatusList", $this->model->getFacheStatusList());
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['product','road','car','coach'])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('product')->visible(['name']);
				$row->getRelation('road')->visible(['roadname']);
				$row->getRelation('car')->visible(['chepaihao']);
				$row->getRelation('coach')->visible(['nickname','mobile']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }

    /**
     * 复制到明天
     */
    public function copytomorrow(){
        $id = input('id',0);
        $info = Db::name('product_chufabanci')->where('id',$id)->find();

        if($this->request->isPost()){

            //准备单条
            $newone = $info;
            unset($newone['id']);

            $newone['ticket_remain'] = $info['ticket_number'];

            $newone['chepaihao'] = '';
            $newone['sijimobile'] = '';

            $newone['fache_status'] = 0;
            $newone['fache_time'] = 0;
            $newone['daozhan_time'] = 0;
            $newone['fache_ready'] = 0;

            //
            $data = [];
            $copydays = input('copydays',1,'intval');
            if(empty($copydays)){
                $copydays = 1;
            }

            for($i=1;$i<=$copydays;$i++){

                $newone['chufatime'] = $info['chufatime'] + (86400*$i);
                $data[] = $newone;
            }

            Db::name('product_chufabanci')->insertAll($data);

            $this->success('复制成功');
        }

        $this->view->assign('row', $info);
        return $this->view->fetch();
    }

}
